/*
 * EDITMAIL.H - Editing tables
 *
 * Msged/Q message editor for QuickBBS  Copyright 1990 by P.J. Muller
 *
 */

void backspace(void);
void delete_character(void);
void go_left(void);
void go_right(void);
void go_word_right(void);
void go_word_left(void);
void newline(void);
void go_up(void);
void go_down(void);
void go_pgup(void);
void go_pgdown(void);
void delete_line(void);
void go_eol(void);
void cut(void);
void paste(void);
void anchor(void);
void quit(void);
void die(void);
void imptxt(void);
void outtext(void);
void shellos(void);
void go_bol(void);
void format(void);
void toggle_ins(void);
void tabit(void);
void go_tos(void);
void go_bos(void);
void go_bom(void);
void go_tom(void);
void killeol(void);

#ifndef EDITMAIL
extern void (*editckeys[])(void);
extern void (*editakeys[])(void);
extern struct _command editcmds[];
#else

/* table of normal keystrokes */

void (*editckeys[256])(void) =
{
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  0 */
backspace,tabit,NULL,	NULL,	NULL,	newline,NULL,	NULL, /*  8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 10 */
NULL,	NULL,	NULL,	die,	NULL,	NULL,	NULL,	NULL, /* 18 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 20 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 28 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 30 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 38 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 40 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 48 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 50 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 58 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 60 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 68 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 70 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	backspace, /* 78 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 80 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 88 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 90 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 98 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* F0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL  /* F8 */
};

/* table of extended keystrokes */

void (*editakeys[])(void) =
{
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /*  8 */
NULL,	outtext,NULL,	NULL,	NULL,	NULL,	NULL,	imptxt,/* 10 */
shellos,paste,	NULL,	NULL,	NULL,	NULL,	anchor, quit, /* 18 */
delete_line,format,NULL,helped,	NULL,	killeol,NULL,	NULL, /* 20 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	cut,	NULL, /* 28 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 30 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 38 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	go_bol, /* 40 */
go_up,	go_pgup,NULL,	go_left,NULL,	go_right,NULL,	go_eol, /* 48 */
go_down,go_pgdown,toggle_ins,delete_character,NULL,NULL,NULL,NULL, /* 50 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 58 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 60 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 68 */
NULL,NULL,NULL,go_word_left,go_word_right,go_bom,go_bos, go_tom,/* 70 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 78 */
NULL,	NULL,	NULL,	NULL,	go_tos, NULL,	NULL,	NULL, /* 80 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 88 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 90 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* 98 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* A8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* B8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* C8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* D8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* E8 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL, /* F0 */
NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL,	NULL  /* F8 */
};

struct _command editcmds[] = {
	{"backspace",backspace},	{"deleol",killeol},
	{"left",go_left},		{"right",go_right},
	{"wordright",go_word_right},	{"wordleft",go_word_left},
	{"newline",newline},		{"up",go_up},
	{"down",go_down},		{"pgup",go_pgup},
	{"pgdn",go_pgdown},		{"delline",delete_line},
	{"goeol",go_eol},		{"cut",cut},
	{"anchor",anchor},		{"paste",paste},
	{"quit",quit},			{"abort",die},
	{"import",imptxt},		{"export",outtext},
	{"shell",shellos},		{"gobol",go_bol},
	{"format",format},		{"insert",toggle_ins},
	{"tab",tabit},			{"null",NULL},
	{"top",go_tos}, 		{"bottom",go_bos},
	{"first",go_tom},		{"last",go_bom},
	{"del",delete_character},	{"edhelp",helped},
	{NULL,NULL}
};
#endif
